#define BIT7 0x80
#define BIT6 0x40
#define BIT5 0x20
#define BIT4 0x10
#define BIT3 0x08
#define BIT2 0x04
#define BIT1 0x02
#define BIT0 0x01

#define HIGH 1
#define LOW 0

#define TRUE 1
#define FALSE 0

#define LOWBYTE(v)   ((unsigned char) (v))
#define HIGHBYTE(v)  ((unsigned char) (((unsigned int) (v)) >> 8))


//USB interface
#define USB_PACKET_SIZE 62
#define TEMP_DATA_LEN 3
#define USB_CMD_LEN 6

#define IDLE 0
//SPI Flow
#define SEND_FIRST_TC_BYTE 1
#define FIRST_TC_BYTE_SENT 2
#define SEND_SECOND_TC_BYTE 3
#define SECOND_TC_BYTE_SENT 4
#define SEND_FIRST_DAC_BYTE 5
#define FIRST_DAC_BYTE_SENT 6
#define SEND_SECOND_DAC_BYTE 7
#define SECOND_DAC_BYTE_SENT 8
//I2C flow
#define MstR_STA_SENT 1
#define MstR_ADDR_SENT 2
#define MstR_READ_BYTE 3
#define MstR_DATA_READY 4

#define MstW_STA_SENT 10
#define MstW_ADDR_SENT 11
#define MstW_BYTE_SENT 12

#define I2C_ACK 1
#define I2C_NACK 0
#define RGB_SENS_ADDR 0x38
#define RGBC_DATA_LEN 8

//DAC
#define DAC_CH_A 1
#define DAC_CH_B 2
#define DAC_CH_C 3
#define DAC_CH_D 4
#define DAC_RGB_R 1
#define DAC_RGB_G 2
#define DAC_RGB_B 3

//global variables shared across files
extern unsigned char SPI_State;
extern unsigned char I2C_State;
extern bit TEMP_DATA_READY;
extern unsigned char TempDataTx[TEMP_DATA_LEN];
extern unsigned char I2C_SlaveAddr;
extern unsigned char I2C_NumReadBytes;
extern unsigned char idata *I2C_WriteBufferPtr;
extern unsigned char I2C_FinalWriteAddress;
extern unsigned char UpdateDAC_FirstByte;
extern unsigned char UpdateDAC_SecondByte;

extern unsigned char idata RGBC_Tx_EnableConv[4];
extern unsigned char idata RGBC_Tx_EnableConv_16x[4];
extern unsigned char idata RGBC_Tx_SetReadFirstRegAddr[3];
extern unsigned char idata RGBC_Tx_SetReadRGBC[3];
extern unsigned char idata RGBC_Rx_RGBC[3];
		#define I2C_RCVBUF_LEN 10
extern unsigned char I2C_RcvData[I2C_RCVBUF_LEN];

extern bit REQUEST_RGBC_DATA;
extern bit REQUEST_TEMP_DATA;

//function prototypes
void TransmitUSB_TempData();
void TransmitUSB_RGBCData();
void myAPICallback();
void I2C_MasterRead(unsigned char*);
void I2C_MasterWrite(unsigned char*);
void Delay_us(unsigned int DelayCount);
void UpdateDAC(unsigned char ChannelABCorD, unsigned char DACcode);
void Delay_10ms(unsigned int DelayCount);

//port pins
sbit DAC_NSS = P2^0;
sbit RGB_INT = P0^6;
sbit TC_NSS = SPI0CN0^2;
sbit P1_1_DEBUG = P1^1;

//SFR pages
#define SMB0_PAGE 0x00
