#include <SI_EFM8UB2_Register_Enums.h>                  // SFR declarations
#include "RGBSensorLEDFeedback_Defs.h"

void Delay_us(unsigned int DelayCount)
{
	unsigned char SFRPage_save = SFRPAGE;
	SFRPAGE = CONFIG_PAGE;

	//first, compensate for the time required to execute all the instructions related to the delay function
	//this compensation is based on empirical measurements with a 12 MHz system clock
	if(DelayCount < 6)
		DelayCount = 6;
	DelayCount = DelayCount - 5;

	TMR5CN0_TR5 = 0;	//make sure Timer5 is stopped
	TMR5CN0_TF5H = 0;	//clear overflow flag
	TMR5 = 0xFFFF - DelayCount; //Timer5 runs at 12MHz/12 = 1 MHz, so counts to overflow = delay in microseconds
	TMR5CN0_TR5 = 1;	//start Timer5
	while(!TMR5CN0_TF5H);	//wait until overflow flag is set
	TMR5CN0_TF5H = 0;	//clear overflow flag
	TMR5CN0_TR5 = 0;	//stop Timer5

	SFRPAGE = SFRPage_save;
}

void Delay_10ms(unsigned int DelayCount)
{
	unsigned int n;

	for(n=0; n<DelayCount; n++)
	{
		Delay_us(10000);
	}
}


